# Self Hosting

This article is intended to be an ever-evolving guide to setting up a self-hosting solution, put together as I try out and learn various steps myself.

## Location ##

I want to host with my own hardware, mostly so I have control over costs but general control and independence reasons are appealing also.

I don't have a static IP and don't really want the fuss of getting and maintaining one, nor making my home IP publically visible. For this reason I've opted to run a small VPS on an external hosting provider to act as a public gateway to locally hosted content via a reverse proxy. I also want to run a VPN on this VPS, so I can access services only visible to my home network while away from it. For the external provider I went with Hetzner for reasons of price, reputation and that they are based in Europe. I wasn't too happy with the extent of personal data they collect during registration but understand there are positives to it also, such as IP ranges not being (as) overrun with crap.

## Hardware ##

I had an old Raspberry Pi laying around but felt it wouldn't have enough juice to handle the bunch of services I had planned for it so grabbed a Raspberry Pi 5 with 8 GB RAM. This seems to have been a wise choice when importing my media libraries at least. 

I had a couple of old SSDs too - one 256 GB and one 2 TB, so hooked them up via PCIe to USB connectors. 

The Pi is running on WiFi at the moment, although I could attach it to Ethernet over the house wiring if there is a performance issue.

## Operating System ##

For now, I've gone with the default Debian image for the Raspberry Pi - although it has plenty of bloat that I don't need. Hopefully in future I can get Guix running on there, which I'm currently using on my laptop.

## Core Services ##

I am planning to set up:

### DNS: Pi-Hole ###

https://docs.pi-hole.net/ Which I want to use for internal DHCP/DNS management, helpful for the likes of NextCloud - however the ad blocking functionality is certainly appealing too.

Followed option 'Alternative 1' here:

```
git clone --depth 1 https://github.com/pi-hole/pi-hole.git Pi-hole
cd "Pi-hole/automated install/"
sudo bash basic-install.sh
```

Before starting off you will need to force the machine to get a static IP, this is through `/etc/network/interfaces`. 

Once set up for my router I needed the pi-hole to act as both DNS and DHCP servers. Did this by forcing the router DHCP server to only assign IP, a fixed one to the pi and then enabling DHCP serving on the Pi.


### VPN: Wireguard ###

I want to use Wireguard to allow access to services on my home network that are not intended to be public. It will also allow serving of services that are meant to be public via the VPS and reverse proxy.

https://www.digitalocean.com/community/tutorials/how-to-set-up-wireguard-on-ubuntu-20-04

### Backup ###

Considering rsync or BorgBackup


### Updates ###

Manual or watchtower

### Monitoring ###

Undecided

## Services ##

### Credentials ###

Vaultwarden

### Email ###

Custom self host for receive with, custom and gmail for sending

### Photos ###

Immich

### Music ###

Navidrome

### Documents ###

Nextcloud

### Calendar, Contacts, Notes ###

Nextcloud

### Code ###

Forgejo

### Personal Site ###

Proxied through VPN and reverse proxy

### Social ###

Self host Mastodon or GoToSocial


